// Programa "Alo Mundo" para C++ e wxWidgets.

// Este programa demonstra a criacao de uma janela com botao. Criado pela extensao do programa
// "alomundo.cpp"

// Adaptado do Tutorial de Jan Bodnar [1] por Bruno Schneider em Junho de 2010.
// [1] http://zetcode.com/tutorials/wxwidgetstutorial/

#include <wx/wx.h>

// Primeiro criar o meu proprio tipo programa (aplicacao).
class MyApp : public wxApp
{
    public:
        // Um programa deve ter o metodo OnInit que sera chamado quando o programa for iniciado.
        virtual bool OnInit();
};

// Macro que cria um laco de tratamento de eventos para uma instancia da classe dada. O pre-processador
// cuida dos detalhes que sao iguais em qualquer programa orientado a eventos.
IMPLEMENT_APP(MyApp)


bool MyApp::OnInit()
{
    // Criar uma janela, com titulo "Alo Mundo", de tamanho 250x150 em qualquer lugar.
    wxFrame* ptJanela = new wxFrame(NULL, wxID_ANY, wxT("Alo Mundo"), wxDefaultPosition, wxSize(250, 150));
    wxPanel* ptPainel = new wxPanel(ptJanela, wxID_ANY);
    wxButton* ptBotao = new wxButton(ptPainel, wxID_ANY, wxT("Botao"), wxPoint(100,100), wxSize(50,30));
    // Marcar a janela como visivel.
    ptJanela->Show(true);

    // Nao destruir a janela. O wxWidgets cuida disso pelo programador.

    // Indicar que a inicializacao ocorreu com sucesso.
    return true;
}

