#include "janela.h"
#include <iostream>

// Classe Janela, para demonstrar uma janela que responde eventos.

enum
{
    ID_BOTAO = 1,
};

Janela::Janela(const wxString& titulo, const wxSize& tamanho, const wxPoint& posicao) :
    wxFrame(NULL, wxID_ANY, titulo, posicao, tamanho),
    ptPainel(new wxPanel(this, wxID_ANY)),
    ptBotao(new wxButton(ptPainel, ID_BOTAO, wxT("Botao")))
{
}

void Janela::QuandoMudarTamanho(wxSizeEvent& e)
{
    int x, y;
    GetClientSize(&x, &y);
    ptPainel->SetSize(x,y);
    int xBt, yBt;
    ptBotao->GetSize(&xBt, &yBt);
    ptBotao->Move((x-xBt)/2, static_cast<int>((y-yBt)*0.8));
}

void Janela::QuandoFechar(wxCloseEvent& evento)
{
    wxMessageDialog* ptDialogoFechar = 
        new wxMessageDialog(NULL,
                            wxT("Tem certeza que quer sair?"),
                            wxT("Confirmação"),
                            wxYES_NO | wxNO_DEFAULT | wxICON_QUESTION);
    int resposta = ptDialogoFechar->ShowModal();
    ptDialogoFechar->Destroy();

    if (resposta == wxID_YES)
        Destroy();
    else
        evento.Veto();
    // Cancelar o evento usando "Veto()" conforme recomendado em
    // http://zetcode.com/tutorials/wxwidgetstutorial/events/
}

void Janela::QuandoClicarBotao(wxCommandEvent& e)
{
}

BEGIN_EVENT_TABLE(Janela, wxFrame)
    EVT_SIZE    (           Janela::QuandoMudarTamanho)
    EVT_BUTTON  (ID_BOTAO,  Janela::QuandoClicarBotao)
    EVT_CLOSE   (           Janela::QuandoFechar)
END_EVENT_TABLE()

// (C) Bruno de Oliveira Schneider, Novembro de 2010

