// Programa "Tratador" para C++ e wxWidgets.

// Este programa demonstra o registro de tratadores de enventos. Criado pela extensao do programa
// "botao.cpp".

#include "janela.h"

// Primeiro criar o meu proprio tipo programa (aplicacao).
class MyApp : public wxApp
{
    public:
        // Um programa deve ter o metodo OnInit que sera chamado quando o programa for iniciado.
        virtual bool OnInit();
};

// Macro que cria um laco de tratamento de eventos para uma instancia da classe dada. O pre-processador
// cuida dos detalhes que sao iguais em qualquer programa orientado a eventos.
IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
    // Criar uma janela, com titulo "Alo Mundo", de tamanho 250x150 em qualquer lugar.
    wxFrame* ptJanela = new Janela(wxT("Minha Janela"), wxSize(350, 250));
    // Marcar a janela como visivel.
    ptJanela->Show();

    // Nao destruir a janela. O wxWidgets cuida disso pelo programador.

    // Indicar que a inicializacao ocorreu com sucesso.
    return true;
}

// (C) Bruno de Oliveira Schneider, Novembro de 2010

